﻿using System.Collections.Generic;
using System.Collections.ObjectModel;
using MiscUtil.Extensions.TimeRelated;

namespace LinqToObjects
{
    static class SampleData
    {
        public static readonly IEnumerable<Employee> Employees;
        public static readonly IEnumerable<Department> Departments;

        static SampleData()
        {
            var sales = new Department { Name = "Sales" };
            var finance = new Department { Name = "Finance" };
            var marketing = new Department { Name = "Marketing" };
            var dev = new Department { Name = "Development" };
            Employees = new ReadOnlyCollection<Employee>(new[] 
                {
                    new Employee { Name = "Jon", Salary = 27000, Department = dev, StartDate = 18.January(2001) },
                    new Employee { Name = "Tony", Salary = 35000, Department = dev, StartDate = 26.June(2002) },
                    new Employee { Name = "Nad", Salary = 60000, Department = marketing, StartDate = 15.February(2001) },
                    new Employee { Name = "Colin", Salary = 50000, Department = sales, StartDate = 20.April(2004) },
                    new Employee { Name = "Steve", Salary = 55000, Department = sales, StartDate = 15.July(2003) },
                    new Employee { Name = "Alex", Salary = 32000, Department = dev, StartDate = 17.March(2001) },
                    new Employee { Name = "Nick", Salary = 42000, Department = dev, StartDate = 4.May(2001) },
                    new Employee { Name = "Paul", Salary = 33000, Department = dev, StartDate = 30.November(2002) },
                    new Employee { Name = "Gordon", Salary = 60000, Department = finance, StartDate = 1.February(2001) },
                    new Employee { Name = "Nigel", Salary = 50000, Department = dev, StartDate = 1.August(2002) },
                    new Employee { Name = "Nick", Salary = 48000, Department = dev, StartDate = 14.September(2003) },

                });
            Departments = new ReadOnlyCollection<Department>(new[] { sales, finance, marketing, dev });
        }
    }
}
