﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace LinqToObjects
{
    class SampleQuery
    {
        static void Main()
        {
            IEnumerable<Employee> employees = SampleData.Employees;
            var query = from p in employees
                        where p.Salary > 33000m
                        orderby p.Name, p.StartDate descending
                        group p by p.Department;

            foreach (var group in query)
            {
                Console.WriteLine("{0}:", group.Key.Name);
                foreach (var employee in group)
                {
                    Console.WriteLine("  {0} (Start date={1:d}, salary={2})",
                        employee.Name, employee.StartDate, employee.Salary);
                }
            }
        }
    }
}
