﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ScratchPad
{
    class ConstraintsDemo
    {
        static void ClassConstraint<T>() where T : class
        {
        }

        // T must be a reference type (not just a class - interfaces are okay too)
        // V must be a non-nullable value type (including enums)
        // Note the multiple "where" bits - not where T : class, V : struct
        // which is what I tend to put by accident!
        static void MultipleConstraints<T, V>()
            where T : class
            where V : struct
        {
        }

        static void Main()
        {
            ClassConstraint<string>();
            MultipleConstraints<string, int>(); // Fine
            // Nullable types are awkward!
            //MultipleConstraints<string, int?>(); // Not a struct?
            //MultipleConstraints<int?, int>(); // Not a class either? Wah?
        }
    }
}
