﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ScratchPad
{
    class IteratorBlocks
    {
        public static IEnumerable<string> GetStringsForever(string initial)
        {
            if (initial == null)
            {
                throw new ArgumentNullException("initial");
            }
            return ReallyGetStringsForever(initial);
        }

        private static IEnumerable<string> ReallyGetStringsForever(string initial)
        {

            string current = initial;
            char nextChar = 'a';
            try
            {
                while (true)
                {
                    current += nextChar;
                    nextChar++;
                    if (nextChar > 'z')
                    {
                        nextChar = 'a';
                    }
                    yield return current;
                }
            }
            finally
            {
                Console.WriteLine("Finished");
            }
        }

        static void Main()
        {
            IEnumerable<string> strings = GetStringsForever("");
            /*
            foreach (string x in strings.Take(10))
            {
                Console.WriteLine(x);
            }
            Console.WriteLine("Done");
             */
            IEnumerator<string> iterator = strings.GetEnumerator();
            for (int i = 0; i < 10; i++)
            {
                iterator.MoveNext();
                Console.WriteLine(iterator.Current);
            }
        }

        static void PseudoUnitTest()
        {
            try
            {
                GetStringsForever(null);
                Console.WriteLine("Fail! Expected exception.");
            }
            catch (ArgumentNullException)
            {
                // We expected this
            }
        }
    }
}
