﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ScratchPad
{
    abstract class Arithmetic
    {
        public static readonly Arithmetic Add = new AddImpl();
        public static readonly Arithmetic Subtract = new SubtractImpl();

        private Arithmetic()
        {
        }

        public abstract int Apply(int lhs, int rhs);

        private class AddImpl : Arithmetic
        {
            public override int Apply(int lhs, int rhs)
            {
                return lhs + rhs;
            }
        }

        private class SubtractImpl : Arithmetic
        {
            public override int Apply(int lhs, int rhs)
            {
                return lhs - rhs;
            }
        }
    }


    class PseudoEnumDemo
    {
        static void Main()
        {
            Console.WriteLine(Arithmetic.Add.Apply(10, 20));
        }
    }
}
