﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace ScratchPad
{
    static class StaticHolder<T>
    {
        public static T Value;

        static StaticHolder()
        {
            Console.WriteLine("Initializing StaticHolder<{0}>", typeof(T));
            Console.WriteLine("It's a {0} type",
                default(T) == null ? "reference (or nullable)" 
                    : "value");
        }

        public class StaticNested<V>
        {
            public static V Value;

            static StaticNested()
            {
                Console.WriteLine("Initializing StaticNested<T={0} V={1}>", 
                    typeof(T), typeof(V));
                // Stop the compiler from being annoying
                Value = default(V);
            }
        }
    }


    class StaticPopQuiz
    {
        static void Main()
        {
            StaticHolder<int>.Value = 10;
            StaticHolder<string>.Value = "hello";

            // Shows that default(int?) == null is true, even with a generic version
            StaticHolder<int?>.Value = null;

            Console.WriteLine(StaticHolder<int>.Value);

            StaticHolder<int>.StaticNested<string>.Value = "nested";
            StaticHolder<string>.StaticNested<int>.Value = 20;
            StaticHolder<Stream>.StaticNested<string>.Value = "hi";
            StaticHolder<string>.StaticNested<string>.Value = "hi";

        }
    }
}
